#ifndef ANIMATOR_H
#define ANIMATOR_H


/**
 * Animator.h: abstract baseclass for all animators.
 *
 * (c) 2007 Thomas Unterthiner
 *
 */


/**
 * An Animator is the graphical representation of a pawn (or other object)
 * Animator are controlled by the pawn they belong to. On every
 * logic-tick, the Animator needs to set where the Animator's
 * current position and the position he will have in the next logic-tick.
 * Every time the "draw" function is then called the Animator will
 * interpolate between these two positions while drawing.
 */
class Animator
{
	public:
		virtual ~Animator() {}

		virtual void draw(float dt) = 0;
};


#endif // ANIMATOR_H
