
/**
 * GameObject.cpp: contains the baseclass for all the objects in the game
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "GameObject.h"
#include "Renderer.h"
//#include <iostream>

GameObject::GameObject(AnimatorPtr animator_, const Vector2D& pos_,
                       const Vector2D& size_)
	: pos(pos_),
	  size(size_),
	  animator(animator_)
{
	Renderer::get().registerAnimator(animator.get());
}

GameObject::~GameObject()
{
	Renderer::get().unregisterAnimator(animator.get());
}


void GameObject::update()
{
}


Vector2D GameObject::calculateNextPosition()
{
	return pos;
}
