#include "GameOverEffect.h"
#include "Clock.h"
#include "ResourceManager.h"
#include "Engine.h"
#include <GL/gl.h>

const float DURATION_SEC = 5; // duration in seconds


GameOverEffect::GameOverEffect()
	: isFinished_(false),
	  startTime(0)
{
	texture = ResourceManager::get().getTexture("data/game_over.bmp");
}


GameOverEffect::~GameOverEffect()
{
}

bool GameOverEffect::isFinished()
{
	return isFinished_;
}

void GameOverEffect::update()
{
	if (startTime == 0)
		startTime = Clock::get().getLogicTicks();
/*
	else
	{
		Time now = Clock::get().getLogicTicks();
		if (now - startTime > DURATION_SEC * Clock::LOGICFRAMES_PER_SECOND)
			isFinished_ = true;
	}
*/
}


void GameOverEffect::draw(float dt)
{
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D, texture);
	glPushMatrix();
	glBegin(GL_QUADS);
	glTexCoord2f(0, 1);
	glVertex2f(0, 0);
	glTexCoord2f(1, 1);
	glVertex2f(Engine::WORLDWIDTH, 0);
	glTexCoord2f(1, 0);
	glVertex2f(Engine::WORLDWIDTH, Engine::WORLDHEIGHT);
	glTexCoord2f(0, 0);
	glVertex2f(0, Engine::WORLDHEIGHT);
	glEnd();
	glPopMatrix();
}
