#include "Pawn.h"
#include <cmath>
//#include <iostream>


Pawn::Pawn(SpriteType sprite, const Vector2D& pos, float speed_, int hp_)
	: SpriteObject(sprite, pos, 0, Vector2D(32, 32)),
	  hp(hp_),
	  direction(0, 0),
	  speed(speed_)
{
}


void Pawn::update()
{
	if (canMove())
		pos += direction * speed;

//	std::cout << "pos: " << pos << "dir: " << direction << "speed: " << speed << '\n';
	SpriteObject::update();
	if (!isAlive())
		onDeath();
}

bool Pawn::isAlive()
{
	return SpriteObject::isAlive() && (hp > 0);
}


void Pawn::hit(int damage)
{
	hp -= damage;
}

bool Pawn::canMove()
{
	return true;
}


Vector2D Pawn::calculateNextPosition()
{
	return pos + direction*speed;
}


void Pawn::setLookingDirection(const Vector2D& lookingDir)
{
	orientation = lookingDir.toDegrees();
//	orientation += 90; // we need to turn 90° so the texture's right
}


