#ifndef PAWN_H
#define PAWN_H

/**
 * Pawn.h: a basic pawn. This is used for zombies and the player-class
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "SpriteObject.h"


/**
 * A pawn is basically a moving object in the game.
 * This can be a zombie or the player-character.
 */
class Pawn : public SpriteObject
{
	public:
		Pawn(SpriteType sprite, const Vector2D& pos, float speed_, int hp);
		virtual void update();
		virtual bool isAlive();
		void hit(int damage);
		void setLookingDirection(const Vector2D& lookingDir);
		virtual Vector2D calculateNextPosition();
		virtual bool canMove();

	protected:
		virtual void onDeath() = 0;

		int hp;
		Vector2D direction;
		float speed;
};

#endif
