#include "PlayerPawn.h"
#include "Game.h"
#include "Shot.h"
#include "Sample.h"
//#include <iostream>

PlayerPawn::PlayerPawn(const Vector2D& pos)
	: Pawn(PLAYER_IDLE, pos, 2.5f, 1),
	  shootSound(PISTOL_SHOT),
	  deathSound(PLAYER_DEAD)
{
//	std::cout << "Player " << this << " born" << std::endl;
}

PlayerPawn::~PlayerPawn()
{
//	std::cout << "Player " << this << " dying" << std::endl;
}


void PlayerPawn::setDirection(const Vector2D& dir)
{
	direction = dir;

	if (dir.x || dir.y)
		changeSprite(PLAYER_MOVING);
	else
		changeSprite(PLAYER_IDLE);
}


void PlayerPawn::shoot()
{
	GameObject* shot(new Shot(pos + size/2, orientation));
	Game::get().registerObject(shot);
	shootSound.play();
}


void PlayerPawn::onDeath()
{
	deathSound.play();
	Game::get().onGameOver();
}
