#ifndef PLAYERPAWN_H
#define PLAYERPAWN_H

#include "Pawn.h"
#include "Sound.h"

class PlayerPawn : public Pawn
{
	public:
		PlayerPawn(const Vector2D& pos);
		~PlayerPawn();

		const Vector2D& getPosition() const {return pos;}

		/** Sets the current moving direction. dir is assumed to be normalized! */
		void setDirection(const Vector2D& dir);

		/** Shoots in the current looking direction */
		void shoot();

	protected:
		virtual void onDeath();
	private:
		Sound shootSound;
		Sound deathSound;
};

#endif // PLAYERPAWN_H
