#ifndef SCOREDISPLAY_H
#define SCOREDISPLAY_H

/**
 * Scoredisplay.h: The gui-element shows the current score.
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "Animator.h"
#include "typedefs.h"
#include <vector>

/**
 * The Scoreboard displays the current score of the player.
 * It also is responsible for drawing itself.
 */
class Scoredisplay : public Animator
{
	public:
		Scoredisplay();
		virtual ~Scoredisplay();

		void update();
		virtual void draw(float dt);
		void addPoints(unsigned int points);
	private:
		unsigned int score;

		static const int DIGITS = 7; /// 7 digits will be drawn

		/*
		 * The digits of the scorebord will cycle madly when new
		 * points are added. The cycletime defines until what
		 * time (in logic ticks) they will cycle before displaying
		 * the correct time.
		 * If digit x cycles it is assumed that all y with y > x cycle too
		 */
//		unsigned int cycleTime[DIGITS];
		Texture digits[DIGITS]; // texture currently used for drawing the digit
		std::vector<Texture> digitTextures;
};



#endif // SCOREBOARD_H
