#ifndef SHOT_H
#define SHOT_H

/**
 * Shot.h: models a shot from a gun
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "SpriteObject.h"
#include "Sound.h"

class Pawn;

class Shot : public SpriteObject
{
	public:
		Shot(const Vector2D& pos, float direction);
		virtual ~Shot();
		virtual void update();
		virtual bool isAlive();

	protected:
		virtual Vector2D calculateNextPosition();

	private:
		void hit(Pawn& p);
		Vector2D velocity;
		Sound hitSound;
		bool isDead;
};

#endif
