#ifndef SOUNDMANAGER_H
#define SOUNDMANAGER_H

#include "Sample.h"
#include <map>

class Engine;
class Mix_Chunk;

class SoundManager
{
	public:
		~SoundManager();


		static SoundManager& get() {return *instance;}
		void play(Sample s) const;

	private:
		typedef std::map<Sample, Mix_Chunk*> SampleMap;
		typedef SampleMap::iterator SampleMapIter;
		SampleMap samples;

		void loadSamples();

		// the Engine creates the only renderer instance and deletes it
		// check the Engine::tearDown for details
		friend class Engine;
		static SoundManager* instance;
		SoundManager();
};



#endif // SOUNDMANAGER_H
