#include "Sprite.h"
#include <GL/gl.h>
#include "Clock.h"
#include "Vector2D.h"
#include "Logger.h"
#include "typedefs.h"


const float COLOR[] = {1, 1, 1, 1};

Sprite::Sprite()
{
//	std::cout << "Sprite " << this << " born\n";
}

Sprite::~Sprite()
{
//	std::cout << "Sprite " << this << " dying\n";
}

void Sprite::draw(const Vector2D& pos, const Vector2D& size, State* state, float angle) const
{
	// change to next frame
	Time now = Clock::get().getAbsoluteTicks();
	if (state->lastFrameChange == 0)
		state->lastFrameChange = now;
	while (now - state->lastFrameChange > frames[state->currentFrame]->displayTime)
	{
		state->lastFrameChange += frames[state->currentFrame]->displayTime;
		++(state->currentFrame);
		state->currentFrame %= frames.size();
		state->lastFrameChange = now;
	}

	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glBindTexture(GL_TEXTURE_2D, frames[state->currentFrame]->texture);
	glPushMatrix();
	glTranslatef(pos.x, pos.y, 0);
/*
	glTranslatef(size.x/2, size.y/2, 0);
	glRotatef(angle, 0, 0, 1);
	glTranslatef(-size.x/2, -size.y/2, 0);
*/

	// yes, i need this strange texture->position mapping ?-)
	glBegin(GL_QUADS);
	glColor4fv(COLOR); // make sure no alpha value is set
	glTexCoord2f(0, 1);
	glVertex2f(0, 0);
	glTexCoord2f(1, 1);
	glVertex2f(size.x, 0);
	glTexCoord2f(1, 0);
	glVertex2f(size.x, size.y);
	glTexCoord2f(0, 0);
	glVertex2f(0, size.y);
	glEnd();

	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}


