#include "SpriteAnimator.h"
#include "Engine.h"
#include "SpriteManager.h"
//#include <iostream>

SpriteAnimator::SpriteAnimator(SpriteType type, const Vector2D& pos, const Vector2D& size_)
	: spriteType(type), curPos(pos),
	  sprite(&(Engine::get().getSpriteManager().getSprite(type))),
	  size(size_)
{
//	std::cout << "Animator " << this << " born\n";
}



SpriteAnimator::~SpriteAnimator()
{
//	std::cout << "Animator " << this << " dying\n";
}

void SpriteAnimator::draw(float dt)
{
	Vector2D pos = curPos + dt * toNextPos;
	sprite->draw(pos, size, &spriteStatus, lookingAngle);
}


void SpriteAnimator::changeSprite(SpriteType type)
{
	if (spriteType == type)
		return;

	sprite = &(Engine::get().getSpriteManager().getSprite(type));
	spriteType = type;
	spriteStatus = Sprite::State();
}


void SpriteAnimator::update(const Vector2D& currentPos, const Vector2D& nextPos, float lookingAngle)
{
	this->curPos = currentPos;
	this->toNextPos = nextPos - currentPos;
	this->lookingAngle = lookingAngle;
}
