#ifndef SPRITEANIMATOR_H
#define SPRITEANIMATOR_H

/**
 * SpriteAnimator.h: an animator based on sprites.
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "Animator.h"
#include "Vector2D.h"
#include "Sprite.h"
#include "SpriteType.h"


/** An animator based on sprites */
class SpriteAnimator : public Animator
{
	public:
		SpriteAnimator(SpriteType sprite, const Vector2D& pos, const Vector2D& size);
		~SpriteAnimator();

		/**
		 * Draws the sprite.
		 * using dt to interpolate between the current and the
		 * next position, and to decide which animation-step
		 * to show
		 */
		virtual void draw(float dt);
		void changeSprite(SpriteType type);
		void update(const Vector2D& currentPos, const Vector2D& nextPos, float lookingAngle);

	private:
		SpriteType spriteType;
		Vector2D curPos;
		Vector2D toNextPos;
		float lookingAngle;
		Sprite::State spriteStatus;
		const Sprite* sprite;
		Vector2D size;
};


#endif
