#ifndef SPRITEMANAGER_H
#define SPRITEMANAGER_H

#include "typedefs.h"
#include "SpriteType.h"
#include <boost/shared_ptr.hpp>
#include <map>

class Sprite;
typedef boost::shared_ptr<Sprite> SpritePtr;

class SpriteManager
{
	public:
		SpriteManager();
		~SpriteManager();

		const Sprite& getSprite(SpriteType type) const;

	private:

		/** Loads a sprite out of a file */
		SpritePtr loadSprite(const char* file) const;

		/** Loads texture from a file and returns the texture-ID. */
		Texture loadTexture(const char* file) const;

		typedef std::map<SpriteType, SpritePtr> SpriteMap;
		SpriteMap sprites;
};



#endif // SPRITEMANAGER_H
