/**
 * SpriteObject.cpp: implementation of the SpriteObject
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include "SpriteObject.h"
#include "SpriteAnimator.h"

SpriteObject::SpriteObject(SpriteType sprite, const Vector2D& pos,
                           float orientation_, const Vector2D& size)
	: GameObject(AnimatorPtr(new SpriteAnimator(sprite, pos, size)), pos, size),
	  orientation(orientation)
{
	spriteAnimator = static_cast<SpriteAnimator*>(animator.get());
}

void SpriteObject::changeSprite(SpriteType type)
{
	spriteAnimator->changeSprite(type);
}

void SpriteObject::update()
{
	spriteAnimator->update(pos, calculateNextPosition(), orientation);
}

