#ifndef VECTOR2D_H
#define VECTOR2D_H
/**
 * Vector2D.h: a basic 2D vector class
 *
 * (c) 2007 Thomas Unterthiner
 *
 */

#include <iosfwd>


const double PI = 3.14159265;


class Vector2D
{
	public:
		float x;
		float y;

		Vector2D(float x, float y);
		Vector2D() : x(0), y(0) {}

		int getX() const {return static_cast<int>(x + 0.5f);}
		int getY() const {return static_cast<int>(y + 0.5f);}
		float toDegrees() const;
		void operator+= (const Vector2D& other);
		void operator-= (const Vector2D& other);
		void operator*= (float f);
		void operator/= (float f);
		void normalize();
};

const Vector2D operator+ (const Vector2D& lhs, const Vector2D& rhs);
const Vector2D operator- (const Vector2D& lhs, const Vector2D& rhs);
const Vector2D operator* (const Vector2D& lhs, float rhs);
const Vector2D operator/ (const Vector2D& lhs, int rhs);
const Vector2D operator* (float lhs, const Vector2D& rhs);
std::ostream& operator<< (std::ostream& stream, const Vector2D& v);


#endif
