#ifndef VECTOR3D_H
#define VECTOR3D_H

/**
 * Vector3D.h: a basic 3D vector class
 *
 * (c) 2007 Thomas Unterthiner
 *
 */


#include <iosfwd>

class Vector3D
{
	public:
		float x;
		float y;
		float z;

		Vector3D(float x, float y, float y);
		Vector3D() : x(0), y(0), z(0) {}

		int getX() const {return static_cast<int>(x);}
		int getY() const {return static_cast<int>(y);}
		int getZ() const {return static_cast<int>(z);}

		void operator+= (const Vector3D& other);
};

std::ostream& operator<< (std::ostream& stream, const Vector3D& v);

#endif // VECTOR3D_H
