#include "Zombie.h"
#include "Game.h"
#include "PlayerPawn.h"
#include "Sample.h"

//#include <iostream>

const int ZOMBIE_DAMAGE = 10;

Zombie::Zombie(const Vector2D& pos, float speed, int hp)
	: Pawn(ZOMBIE_MOVING, pos, speed, hp)
{
//	std::cout << "zombie pos: " << pos << '\n';
}


Zombie::~Zombie()
{
}

void Zombie::update()
{
	const Vector2D& playerPos = Game::get().getPlayerPawn().getPosition();
	direction = playerPos - pos;
	direction.normalize();
	setLookingDirection(direction);
	Pawn::update();
	if (isTouchingThePlayer())
		Game::get().getPlayerPawn().hit(ZOMBIE_DAMAGE);
}

bool Zombie::isAlive()
{
	bool isLiving = Pawn::isAlive();
	if (!isLiving)
		Game::get().unregisterZombie(this);
	return isLiving;
}


bool Zombie::canMove()
{
	if (!Pawn::canMove() || isTouchingThePlayer())
	{
		changeSprite(ZOMBIE_IDLE);
		return false;
	}
	changeSprite(ZOMBIE_MOVING);
	return true;
}

bool Zombie::isTouchingThePlayer()
{
	const Pawn& tmp = Game::get().getPlayerPawn();
	Vector2D ppos = tmp.getPosition();
	Vector2D psize = tmp.getSize();

	if ((pos.x >= ppos.x && pos.x <= ppos.x + psize.x)
		|| (pos.x + size.x >= ppos.x && pos.x + size.x <= ppos.x + psize.x))
	{
		if ((pos.y >= ppos.y && pos.y <= ppos.y + psize.y)
		|| (pos.y + size.y >= ppos.y && pos.y + size.y <= ppos.y + psize.y))
		{
			return true;
		}
	}
	return false;
}


void Zombie::onDeath()
{
	Game::get().onZombieDeath(this);
}
